//---------------------------------------------------------------------------

#pragma hdrstop

/*
     #define DEBUG,    
    "data.log".    
    .
..      
#ifdef DEBUG
 ...
#endif
      .
*/
//#define DEBUG

#include "Player.h"
#include "Basket.h"
#include <stdlib.h>

#ifdef DEBUG
  #include <fstream.h>
  #include <iomanip.h>
#endif

  #ifdef DEBUG
    ofstream logFile("data.log", ios::app);
  #endif
//---------------------------------------------------------------------------
Player::Player(Basket *b, short recDepth)
{
  basketPtr = b;
  recursionDepth = recDepth;
  size = NUMB_OF_COL * MAX_VALUE * recursionDepth;
  sizeB = NUMB_OF_COL * MAX_VALUE;
  possibleSteps = new short[size];
  CleanArrays();
}
//---------------------------------------------------------------------------
bool Player::NextStep(short &n, short &c)
{
  color = numb = 0;
  Basket tempB = *basketPtr;
  CleanArrays();
  analizeSteps(tempB, 0, 0);
  #ifdef DEBUG
    logFile << "    (, , ): "
            << setw(3) << basketPtr->getBalls(RED)
            << setw(3) << basketPtr->getBalls(BLUE)
            << setw(3) << basketPtr->getBalls(GREEN)
            << endl
            << " possibleSteps :"
            << endl;
    int count = 0;
    for(int i = 0; i < size; i++)
    {
      logFile << setw(5) << possibleSteps[i];
      if(count == MAX_VALUE * NUMB_OF_COL - 1)
      {
        logFile << endl;
        count = 0;
      }
      else count++;
    }
  #endif
  bool res = selectStep();
  #ifdef DEBUG
    logFile << " bestSteps :" << endl;
    for(int i = 0; i < sizeB; i++)
      logFile << setw(5) << bestSteps[i];
    logFile << endl;
  #endif
  if(!res)
  {
    #ifdef DEBUG
    logFile << "  " << endl;
    #endif
    return false;
  }
  if(!basketPtr->Add(numb, color))
  {
    #ifdef DEBUG
    logFile << "   " << endl;
    #endif
    return false;
  }
  #ifdef DEBUG
    logFile << "  (, ): "
            << setw(3) << color
            << setw(3) << numb << endl;
  #endif
  n = numb;
  c = color;
  return true;
}
//---------------------------------------------------------------------------
bool Player::setRecDepth(short d)
{
  if(d >= 1 && d <= 10)
  {
    if(possibleSteps != 0)
      delete [] possibleSteps;
    size = NUMB_OF_COL * MAX_VALUE * d;
    possibleSteps = new short[size];
    recursionDepth = d;

    return true;
  }
  return false;
}
//---------------------------------------------------------------------------
bool Player::checkStep(short numb, short color)
{
  short temp = basketPtr->getBalls(color) + numb;
  if(temp <= MAX_VALUE && temp >= 0)
    return true;
  return false;
}
//---------------------------------------------------------------------------
void Player::analizeSteps(Basket b, short recNumb, short index)
{
  if(recNumb >= recursionDepth)
    return;
  for(short color = 0; color < NUMB_OF_COL; color++)
    for(short numb = 1; numb <= MAX_VALUE; numb++)
    {
      if(recNumb == 0 && checkStep(numb, color) == false)
        possibleSteps[color*MAX_VALUE + (numb - 1)] = -127;
      else
      {
        Basket b1 = b;
        if(b1.Add(numb, color)) //   
          if(b1.isFull())
          {
            if(recNumb == 0)
              possibleSteps[recNumb * MAX_VALUE * NUMB_OF_COL
                     + color * MAX_VALUE + (numb - 1)] = 1;
            else
              possibleSteps[recNumb * MAX_VALUE * NUMB_OF_COL
                     + index] = 1;
          }
          else
          {
            short rN = recNumb + 1;
            analizeSteps(b1, rN, color * MAX_VALUE + (numb - 1));
          }
      }
    }
}
//---------------------------------------------------------------------------
bool Player::selectStep()
{
//  bestSteps
  for(int i = 0; i < sizeB; i++)
    if(possibleSteps[i] == -127)
      bestSteps[i] = -127;
    else
      for(int j = 0; j < recursionDepth; j++)
        if(j%2 == 0)
          bestSteps[i] += possibleSteps[j*sizeB + i] *
                                      (recursionDepth - j);
        else
          bestSteps[i] += (-1) * possibleSteps[j*sizeB + i] *
                                      (recursionDepth - j);
// 
  int max = -127;
  int count = 0;
  for(int i = 0; i < sizeB; i++)
    {
      if(bestSteps[i] == max)
        count++;
      if(bestSteps[i] > max)
      {
        max = bestSteps[i];
        count = 1;
      }
    }
  #ifdef DEBUG
    logFile << "max = " << max << "; count = " << count << endl;
  #endif
  if(count == 0)
    return false;
  srand(time(NULL));
  int N = rand()%count;
  int curN = 0;
  for(int i = 0; i < sizeB; i++)
    if(bestSteps[i] == max)
    {
      if(N == curN)
      {
        color = i / NUMB_OF_COL;
        numb = i % NUMB_OF_COL + 1;
        break;
      }
      curN++;
    }
  #ifdef DEBUG
    logFile << "color = " << color << "; numb = " << numb << endl;
  #endif
  return true;
}
//---------------------------------------------------------------------------
void Player::CleanArrays()
{
  for(int i = 0; i < size; i++)
    possibleSteps[i] = 0;
  for(int i = 0; i < sizeB; i++)
    bestSteps[i] = 0;
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
